# Generated by Django 2.2.28 on 2022-05-25 12:09

from django.conf import settings
from django.db import migrations


def create_fc_authenticator(apps, schema_editor):
    authorize_url = getattr(settings, 'A2_FC_AUTHORIZE_URL', '')
    if authorize_url == 'https://fcp.integ01.dev-franceconnect.fr/api/v1/authorize':
        platform = 'test'
    elif authorize_url == 'https://app.franceconnect.gouv.fr/api/v1/authorize':
        platform = 'prod'
    else:
        return

    kwargs_settings = getattr(settings, 'AUTH_FRONTENDS_KWARGS', {})
    authenticator_settings = kwargs_settings.get('fc', {})

    priority = authenticator_settings.get('priority')
    priority = priority if priority is not None else -1

    client_id = getattr(settings, 'A2_FC_CLIENT_ID', '') or ''
    client_secret = getattr(settings, 'A2_FC_CLIENT_SECRET', '') or ''

    FcAuthenticator = apps.get_model('authentic2_auth_fc', 'FcAuthenticator')
    FcAuthenticator.objects.create(
        slug='fc-authenticator',
        order=priority,
        show_condition=authenticator_settings.get('show_condition') or '',
        enabled=bool(getattr(settings, 'A2_FC_ENABLE', False) and client_id and client_secret),
        platform=platform,
        client_id=client_id[:256],
        client_secret=client_secret[:256],
        scopes=getattr(settings, 'A2_FC_SCOPES', []) or ['profile', 'email'],
    )


class Migration(migrations.Migration):

    dependencies = [
        ('authentic2_auth_fc', '0005_fcauthenticator'),
    ]

    operations = [
        migrations.RunPython(create_fc_authenticator, reverse_code=migrations.RunPython.noop),
    ]
